package entities 
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	/**
	 * ...
	 * @author Bradley Davies (@DPbrad)
	 */
	public class Player extends Entity
	{
		
		private var _image:Image;
		
		private var _dX:Number=0, _dY:Number=0;
		
		public function Player(x:int,y:int) 
		{
			_image = Image.createRect(28, 28, 0xAAFF9A);
			super(x, y, _image); setHitboxTo(graphic);
		}
		
		override public function added():void 
		{
			super.added();
			
		}
		
		override public function update():void 
		{
			super.update();
			//First, lets see if he is on solid ground!
			var iX:int = 0;
			if (Input.check(Key.A)) iX--; if (Input.check(Key.D)) iX++;
			//
			_dX = 200 * FP.elapsed * iX;
			//
			//
			var colliders:Entity = collideTypes(["solid", "movingSolid"], x, y + 1);
			if (colliders)
			{
				_dY = 0;
				
				if (colliders is MovingPlatform)
				{
					_dX += MovingPlatform(colliders).dX;
				}
				if (Input.pressed(Key.SPACE))
				{
					_dY = -10;
				}
			}
			else
			{
				_dY += 30 * FP.elapsed;
			}
			
			moveBy(_dX, _dY, ["solid", "movingSolid"]);
		}
		
	}

}